package com.glxp.sale.admin.controller.inout;

import com.github.pagehelper.PageInfo;
import com.glxp.sale.admin.constant.ConstantStatus;
import com.glxp.sale.admin.controller.inout.utils.ContrastErpUtil;
import com.glxp.sale.admin.entity.inout.*;
import com.glxp.sale.admin.entity.param.SystemParamConfigEntity;
import com.glxp.sale.admin.entity.thrsys.ThrOrderDetailEntity;
import com.glxp.sale.admin.entity.thrsys.ThrOrderEntity;
import com.glxp.sale.admin.httpclient.ErpOrderClient;
import com.glxp.sale.admin.req.inout.*;
import com.glxp.sale.admin.req.param.SystemParamConfigRequest;
import com.glxp.sale.admin.req.thrsys.FilterThrOrderDetailRequest;
import com.glxp.sale.admin.req.thrsys.FilterThrOrderRequest;
import com.glxp.sale.admin.res.PageSimpleResponse;
import com.glxp.sale.admin.res.inout.ErpOrderResponse;
import com.glxp.sale.admin.res.inout.PurchaseinResponse;
import com.glxp.sale.admin.service.basic.UdiInfoService;
import com.glxp.sale.admin.service.basic.UdiRelevanceService;
import com.glxp.sale.admin.service.inout.*;
import com.glxp.sale.admin.service.param.SystemParamConfigService;
import com.glxp.sale.admin.service.thrsys.ThrOrderDetailService;
import com.glxp.sale.admin.service.thrsys.ThrOrderService;
import com.glxp.sale.admin.thread.InvDlErpStockService;
import com.glxp.sale.admin.thread.IoTransInoutService;
import com.glxp.sale.common.enums.ResultEnum;
import com.glxp.sale.common.res.BaseResponse;
import com.glxp.sale.common.util.ResultVOUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@RestController
public class OrderDetailController {

    @Resource
    OrderDetailService orderDetailService;
    @Resource
    UdiInfoService udiInfoService;
    @Resource
    CodesService codesService;
    @Resource
    OrderService orderService;
    @Resource
    private UdiRelevanceService udiRelevanceService;
    @Resource
    private InvDlErpStockService dlErpStockService;


    @Resource
    private IoTransInoutService transInoutService;
    @Autowired
    private SystemParamConfigService systemParamConfigService;

    @Resource
    private ThrOrderService thrOrderService;
    @Resource
    private ThrOrderDetailService thrOrderDetailService;

    @Resource
    private StockOrderService stockOrderService;
    @Resource
    private StockOrderDetailService stockOrderDetailService;

    @GetMapping("/udiwms/erpOrder/filter")
    public BaseResponse filterErpOrder(FilterOrderRequest filterErpOrderRequest,
                                       BindingResult bindingResult) {

        if (bindingResult.hasErrors()) {
            return ResultVOUtils.error(ResultEnum.PARAM_VERIFY_FALL, bindingResult.getFieldError().getDefaultMessage());
        }

//        BasicThirdSysDetailEntity basicThirdSysDetailEntity = bussinessTypeService.findByActionKey(filterErpOrderRequest.getBillAction(), "orderQueryUrl");
//        if (basicThirdSysDetailEntity.getValue() == null) {
//            return ResultVOUtils.error(500, "业务单据查询接口未定义");
//        }
//        if(!basicThirdSysDetailEntity.getEnabled()){
//            return ResultVOUtils.error(500, "第三方业务单据服务未启用");
//        }
//
//        if (basicThirdSysDetailEntity.getFromType() == 0  && !basicThirdSysDetailEntity.getItrCache()) {
//
//            return new ErpOrderClient(basicThirdSysDetailEntity.getValue()).getErpOrderResponse(filterErpOrderRequest);
//        } else {
        //todo 订单查询，需加日期
        FilterThrOrderRequest filterThrOrderRequest = new FilterThrOrderRequest();
        BeanUtils.copyProperties(filterErpOrderRequest, filterThrOrderRequest);
//            if (filterThrOrderRequest.getBillAction() != null) {
//                BussinessTypeEntity bussinessTypeEntity = bussinessTypeService.findBTByAction(filterErpOrderRequest.getBillAction());
//                filterThrOrderRequest.setBillAction(bussinessTypeEntity.getName());
//            }
        filterThrOrderRequest.setPage(filterErpOrderRequest.getPage());
        filterThrOrderRequest.setLimit(filterErpOrderRequest.getLimit());
        List<ErpOrderResponse> erpOrderResponses = new ArrayList<>();
        List<ThrOrderEntity> data = thrOrderService.filterThrOrder(filterThrOrderRequest);
        if (data != null && data.size() > 0) {
            for (ThrOrderEntity thrOrderEntity : data) {
                FilterThrOrderDetailRequest filterThrOrderDetailRequest = new FilterThrOrderDetailRequest();
                filterThrOrderDetailRequest.setOrderIdFk(thrOrderEntity.getId() + "");
                List<ThrOrderDetailEntity> thrOrderDetailEntities =
                        thrOrderDetailService.filterThrOrderDetailDetail(filterThrOrderDetailRequest);
                ErpOrderResponse erpOrderResponse = new ErpOrderResponse();
                BeanUtils.copyProperties(thrOrderEntity, erpOrderResponse);
                List<ErpOrderResponse.SubErpOrder> subErpOrders = new ArrayList<>();
                if (thrOrderDetailEntities != null && thrOrderDetailEntities.size() > 0) {
                    for (ThrOrderDetailEntity thrOrderDetailEntity : thrOrderDetailEntities) {
                        ErpOrderResponse.SubErpOrder subErpOrder = new ErpOrderResponse.SubErpOrder();
                        BeanUtils.copyProperties(thrOrderDetailEntity, subErpOrder);
                        subErpOrders.add(subErpOrder);
                    }
                }
                erpOrderResponse.setSubErpOrders(subErpOrders);
                erpOrderResponses.add(erpOrderResponse);
            }
        }
        PageInfo<ThrOrderEntity> pageInfo;
        pageInfo = new PageInfo<>(data);
        PageSimpleResponse<ErpOrderResponse> pageSimpleResponse = new PageSimpleResponse<>();
        pageSimpleResponse.setTotal(pageInfo.getTotal());
        pageSimpleResponse.setList(erpOrderResponses);
        return ResultVOUtils.success(pageSimpleResponse);
//        }
    }

    @GetMapping("/udiwms/erpOrder/addStockOrder")
    public BaseResponse addStockOrder(FilterOrderRequest filterErpOrderRequest,
                                       BindingResult bindingResult) {

        if (bindingResult.hasErrors()) {
            return ResultVOUtils.error(ResultEnum.PARAM_VERIFY_FALL, bindingResult.getFieldError().getDefaultMessage());
        }

        ThrOrderEntity thrOrderEntity = thrOrderService.findById(String.valueOf(filterErpOrderRequest.getId()));
        if (thrOrderEntity == null) {
            return ResultVOUtils.error(ResultEnum.DATA_NOT);
        }
        StockOrderEntity stockOrderEntity = new StockOrderEntity();
        BeanUtils.copyProperties(thrOrderEntity, stockOrderEntity);
        stockOrderEntity.setId(null);
        stockOrderEntity.setStatus("101");//未提交
        stockOrderEntity.setSourceType("2");//外部提交
        stockOrderEntity.setStatus2("101");//未打印
        boolean b = stockOrderService.insertStockOrder(stockOrderEntity);
        if (b) {
            FilterThrOrderDetailRequest filterThrOrderDetailRequest = new FilterThrOrderDetailRequest();
            filterThrOrderDetailRequest.setOrderIdFk(thrOrderEntity.getId() + "");
            List<ThrOrderDetailEntity> thrOrderDetailEntities =
                    thrOrderDetailService.filterThrOrderDetailDetail(filterThrOrderDetailRequest);
            if (thrOrderDetailEntities != null && thrOrderDetailEntities.size() > 0) {
                List<StockOrderDetailEntity> stockOrderDetailEntityList = new ArrayList<>();
                for (ThrOrderDetailEntity thrOrderDetailEntity : thrOrderDetailEntities) {
                    StockOrderDetailEntity stockOrderDetailEntity = new StockOrderDetailEntity();
                    BeanUtils.copyProperties(thrOrderDetailEntity, stockOrderDetailEntity);
                    stockOrderDetailEntity.setOrderIdFk(stockOrderEntity.getId());
                    stockOrderDetailEntity.setSweepCount(0 + "");
                    stockOrderDetailEntityList.add(stockOrderDetailEntity);
                }
                stockOrderDetailService.insertStockOrderDetails(stockOrderDetailEntityList);
            }
        }

        return ResultVOUtils.success();
    }


    @GetMapping("/warehouse/getMyErpOrders")
    public BaseResponse getMyErpOrders(FilterErpOrderRequest filterErpOrderRequest,
                                       BindingResult bindingResult) {

        if (bindingResult.hasErrors()) {
            return ResultVOUtils.error(ResultEnum.PARAM_VERIFY_FALL, bindingResult.getFieldError().getDefaultMessage());
        }
        if (filterErpOrderRequest.getErpOrderId() == null || filterErpOrderRequest.getErpOrderId().equals("")) {
            filterErpOrderRequest.setErpOrderId("null");
        }
        List<ErpOrderEntity> erpInfoEntityList = orderDetailService.filterMyErpDetailOrder(filterErpOrderRequest);
        PageInfo<ErpOrderEntity> pageInfo;
        pageInfo = new PageInfo<>(erpInfoEntityList);
        PageSimpleResponse<ErpOrderEntity> pageSimpleResponse = new PageSimpleResponse<>();
        pageSimpleResponse.setTotal(pageInfo.getTotal());
        pageSimpleResponse.setList(erpInfoEntityList);
        return ResultVOUtils.success(pageSimpleResponse);
    }


    @PostMapping("/warehouse/deleteErpOrder")
    public BaseResponse deleteErpOrder(@RequestBody DeleteRequest deleteRequest, BindingResult bindingResult) {

        if (bindingResult.hasErrors()) {
            return ResultVOUtils.error(ResultEnum.PARAM_VERIFY_FALL, bindingResult.getFieldError().getDefaultMessage());
        }
        boolean b = orderDetailService.deleteById(deleteRequest.getId());
        if (b) {
            return ResultVOUtils.success("删除成功");
        } else {
            return ResultVOUtils.error(500, "删除失败");
        }
    }

    @GetMapping(value = "/warehouse/inout/order/detail")//TODO 订单详情
    public BaseResponse orderDetail(FilterErpOrderRequest filterErpOrderRequest,
                                    BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            return ResultVOUtils.error(ResultEnum.PARAM_VERIFY_FALL, bindingResult.getFieldError().getDefaultMessage());
        }
        if (filterErpOrderRequest.getOrderId() == null || filterErpOrderRequest.getOrderId().equals("")) {
            filterErpOrderRequest.setOrderId("1");
        }
        filterErpOrderRequest.setPage(1);
        filterErpOrderRequest.setLimit(100);
        List<ErpOrderEntity> erpOrderEntities = orderDetailService.filterMyErpOrder(filterErpOrderRequest);
        return ResultVOUtils.success(erpOrderEntities);
    }

    @GetMapping(value = "/warehouse/inout/order/uploadOrder")
    public BaseResponse uploadOrder(FilterErpOrderRequest filterErpOrderRequest,
                                    BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            return ResultVOUtils.error(ResultEnum.PARAM_VERIFY_FALL, bindingResult.getFieldError().getDefaultMessage());
        }
        if (filterErpOrderRequest.getOrderId() == null || filterErpOrderRequest.getOrderId().equals("")) {
            return ResultVOUtils.error(500, "上传失败");
        }

        filterErpOrderRequest.setPage(1);
        filterErpOrderRequest.setLimit(100);
        List<ErpOrderEntity> erpOrderEntities = orderDetailService.filterMyErpOrder(filterErpOrderRequest);
        OrderFilterRequest orderFilterRequest = new OrderFilterRequest();
        orderFilterRequest.setId(filterErpOrderRequest.getOrderId());
        OrderEntity orderEntity = orderService.findOne(orderFilterRequest);
        if (erpOrderEntities != null) {
            for (int i = 0; i < erpOrderEntities.size(); i++) {
                if (erpOrderEntities.get(i).getErpOrderId() == null) {
                    return ResultVOUtils.error(500, "批次号不匹配，请检查后修改！");
                }

                if (erpOrderEntities.get(i).getErpOrderId().contains(",")) {
                    return ResultVOUtils.error(500, "无法修改合并单据！");
                }

                if (erpOrderEntities.get(i).getCount() > erpOrderEntities.get(i).getErpCount()) {
                    return ResultVOUtils.error(500, "扫码数量大于实际数量,无法修改！");
                }
            }
        }
        SystemParamConfigRequest systemParamConfigRequest = new SystemParamConfigRequest();
        systemParamConfigRequest.setParamKey("erp_order_modify");
        SystemParamConfigEntity systemParamConfigEntity = systemParamConfigService.selectByParamKey(systemParamConfigRequest);
        if (systemParamConfigEntity == null)
            return ResultVOUtils.error(500, "ERP出入库单据修改接口未定义");
        String url = systemParamConfigEntity.getParamValue();
        Map<String, List<ErpOrderEntity>> listMap = erpOrderEntities.stream().collect(Collectors.groupingBy(ErpOrderEntity::getErpOrderId));
        BaseResponse baseResponse = new ErpOrderClient().postBill(listMap, orderEntity.getAction(), url);
        if (baseResponse != null && baseResponse.getCode() == 20000) {
            orderService.updateExportStatus(orderEntity.getId(), ConstantStatus.ORDER_EXPORT_ED);
            return ResultVOUtils.success("修改成功");
        } else {
            if (baseResponse != null) {
                return ResultVOUtils.error(500, baseResponse.getMessage());
            }
            return ResultVOUtils.error(500, "修改失败");
        }
    }


    @GetMapping("/warehouse/dlErpStock1")
    public BaseResponse dlErpStock() {
        dlErpStockService.dlErpStock();
        return ResultVOUtils.success("后台已自动更新，请稍后刷新查看！");
    }

    @PostMapping("/warehouse/selectErpOrder")
    public BaseResponse selectErpOrder(@RequestBody ImportErpOrderRequest importErpOrderRequest, BindingResult bindingResult) {

        if (bindingResult.hasErrors()) {
            return ResultVOUtils.error(ResultEnum.PARAM_VERIFY_FALL, bindingResult.getFieldError().getDefaultMessage());
        }
        List<PurchaseinResponse> docids = importErpOrderRequest.getPurchaseinResponses();
        String docidStr = "";
        if (docids != null && docids.size() > 0) {
            for (PurchaseinResponse temp : docids) {
                docidStr = docidStr + "," + temp.getVbillcode();
            }
            docidStr = docidStr.substring(1);
        }
        List<ErpOrderEntity> erpOrderEntities = new ArrayList<>();
        if (docids != null && docids.size() > 0) {
            for (PurchaseinResponse purchaseinResponse : docids) {
                for (PurchaseinResponse.SubPurchase subPurchase : purchaseinResponse.getSubPurchases()) {
                    ErpOrderEntity erpOrderEntity = new ErpOrderEntity();
                    erpOrderEntity.setErpOrderId(purchaseinResponse.getVbillcode());
                    erpOrderEntity.setCompanyid(purchaseinResponse.getProvider_code());
                    erpOrderEntity.setCompanyname(purchaseinResponse.getProvider_name());
                    erpOrderEntity.setCredate(purchaseinResponse.getDbilldate());
                    erpOrderEntity.setGoodsid(subPurchase.getInventory_code());
                    erpOrderEntity.setGoodsname(subPurchase.getInventory_name());
                    erpOrderEntity.setBatchNo(subPurchase.getVbatchcode());
                    erpOrderEntity.setErpCount(Math.abs(subPurchase.getDtlgoodsqty()));
                    erpOrderEntity.setReCount(Math.abs(subPurchase.getReCount()));
                    erpOrderEntity.setGoodsunit(subPurchase.getInvspec());
                    erpOrderEntities.add(erpOrderEntity);
                }
            }
        }
        if (erpOrderEntities != null && erpOrderEntities.size() > 0) {
            ErpOrderEntity temp = erpOrderEntities.get(0);
            for (int i = 0; i < erpOrderEntities.size(); i++) {
                if (!temp.getCompanyname().equals(erpOrderEntities.get(i).getCompanyname())) {
                    return ResultVOUtils.error(500, "选择Erp订单往来单位不一致！");
                }
            }

            OrderFilterRequest orderFilterRequest = new OrderFilterRequest();
            orderFilterRequest.setId(importErpOrderRequest.getOrderId());
            OrderEntity orderEntity = orderService.findOne(orderFilterRequest);
            ErpOrderEntity exitErp = new ContrastErpUtil().vailErpExit(orderDetailService, erpOrderEntities, importErpOrderRequest.getOrderId());
            if (exitErp != null) {
                String errMsg = "所选ERP单" + exitErp.getErpOrderId() + "已被其他出入库单" + exitErp.getOrderIdFk() + "绑定";
                orderEntity.setRemark(errMsg);
                orderService.updateOrder(orderEntity);
                return ResultVOUtils.error(500, errMsg);
            } else {
                orderEntity.setErpFk(docidStr);
                orderService.updateOrder(orderEntity);
            }

            orderDetailService.deleteByOrderId(importErpOrderRequest.getOrderId());
            List<ErpOrderEntity> returnOrders = new ContrastErpUtil().transErp(erpOrderEntities, udiRelevanceService, importErpOrderRequest.getOrderId());
            orderDetailService.insertErpOrders(returnOrders);
            List<WarehouseEntity> warehouseEntityList = codesService.findByReceiptId(importErpOrderRequest.getOrderId());
            new ContrastErpUtil().contrastErp(udiInfoService, udiRelevanceService, orderDetailService, orderService, warehouseEntityList, systemParamConfigService);


        } else {
            return ResultVOUtils.error(500, "ERP订单不能为空");
        }

        return ResultVOUtils.success("导入成功");
    }


    @PostMapping("/warehouse/repeatCheck")//TODO 重新校验
    public BaseResponse repeatCheck(@RequestBody FilterErpOrderRequest filterErpOrderRequest, BindingResult bindingResult) {

        if (bindingResult.hasErrors()) {
            return ResultVOUtils.error(ResultEnum.PARAM_VERIFY_FALL, bindingResult.getFieldError().getDefaultMessage());
        }
        OrderFilterRequest orderFilterRequest = new OrderFilterRequest();
        orderFilterRequest.setId(filterErpOrderRequest.getOrderId());
        OrderEntity orderEntity = orderService.findOne(orderFilterRequest);
        transInoutService.repeatCheck(orderEntity.getId());
        return ResultVOUtils.success("后台已开始校验，请稍后刷新重试！");
    }


}
